Foreman's HasManyCommon concern uses 'id' for a method Rails expects to return a string
Status: Closed   

Priority: Normal   

Assignee: Stephen Benjamin   

Category: Rails   

Target version: 1.19.0   

Difficulty:  Fixed in Releases: 1.19.0

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/5732

  

Description

Foreman HasManyCommon concern uses 'id' as a value of last resort for the name of an attribute.  But Rails expects this value to a

return a string.  This causes a problem for Katello.  Take a look at the output here in Katello:

irb(main):001:0> Host.first

Hirb Error: undefined method `gsub' for 2:Integer

</rep>

Where's that coming from?

<pre>

irb(main):006:0> Host.first.content_facet_attributes.to_s

=> 2

irb(main):007:0> Host.first.content_facet_attributes.to_s.is_a?(String)

=> false

</pre>

Foreman should use a method that returns string as a last resort.

Associated revisions

Revision ae96cb70 - 06/25/2018 03:08 PM - Stephen Benjamin

fixes #24046 - return id as str for name as last resort

Foreman HasManyCommon concern uses 'id' as a value of last resort for

the name of an attribute. But Rails expects this value to a return a

string. This causes a problem for Katello. Take a look at the output

here in Katello:

```

irb(main):001:0> Host.first

Hirb Error: undefined method `gsub' for 2:Integer

```

Where's that coming from?

```

irb(main):006:0> Host.first.content_facet_attributes.to_s

=> 2

irb(main):007:0> Host.first.content_facet_attributes.to_s.is_a?(String)

=> false

```

History

#1 - 06/22/2018 02:14 PM - The Foreman Bot
- Status changed from New to Ready For Testing

- Assignee set to Stephen Benjamin

- Pull request https://github.com/theforeman/foreman/pull/5732 added

#2 - 06/25/2018 03:08 PM - Tomer Brisker

- translation missing: en.field_release set to 353

#3 - 06/25/2018 04:01 PM - Stephen Benjamin

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset ae96cb70130968bdcc8b7a9a9af7edc7c6e0d9a8.
